/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package fixtures.bodycomplex;

import com.microsoft.rest.ServiceClient;
import com.squareup.okhttp.OkHttpClient;
import retrofit.Retrofit;

/**
 * Initializes a new instance of the AutoRestComplexTestService class.
 */
public final class AutoRestComplexTestServiceImpl extends ServiceClient implements AutoRestComplexTestService {
    /**
     * The URI used as the base for all cloud service requests.
     */
    private final String baseUri;

    /**
     * Gets the URI used as the base for all cloud service requests.
     * @return The BaseUri value.
     */
    public String getBaseUri() {
        return this.baseUri;
    }

    /**
     * Gets the BasicOperations object to access its operations.
     * @return the BasicOperations object.
     */
    public BasicOperations getBasicOperations() {
        return new BasicOperationsImpl(this.retrofitBuilder.build(), this);
    }

    /**
     * Gets the PrimitiveOperations object to access its operations.
     * @return the PrimitiveOperations object.
     */
    public PrimitiveOperations getPrimitiveOperations() {
        return new PrimitiveOperationsImpl(this.retrofitBuilder.build(), this);
    }

    /**
     * Gets the ArrayOperations object to access its operations.
     * @return the ArrayOperations object.
     */
    public ArrayOperations getArrayOperations() {
        return new ArrayOperationsImpl(this.retrofitBuilder.build(), this);
    }

    /**
     * Gets the DictionaryOperations object to access its operations.
     * @return the DictionaryOperations object.
     */
    public DictionaryOperations getDictionaryOperations() {
        return new DictionaryOperationsImpl(this.retrofitBuilder.build(), this);
    }

    /**
     * Gets the InheritanceOperations object to access its operations.
     * @return the InheritanceOperations object.
     */
    public InheritanceOperations getInheritanceOperations() {
        return new InheritanceOperationsImpl(this.retrofitBuilder.build(), this);
    }

    /**
     * Gets the PolymorphismOperations object to access its operations.
     * @return the PolymorphismOperations object.
     */
    public PolymorphismOperations getPolymorphismOperations() {
        return new PolymorphismOperationsImpl(this.retrofitBuilder.build(), this);
    }

    /**
     * Gets the PolymorphicrecursiveOperations object to access its operations.
     * @return the PolymorphicrecursiveOperations object.
     */
    public PolymorphicrecursiveOperations getPolymorphicrecursiveOperations() {
        return new PolymorphicrecursiveOperationsImpl(this.retrofitBuilder.build(), this);
    }

    /**
     * Initializes an instance of AutoRestComplexTestService client.
     */
    public AutoRestComplexTestServiceImpl() {
        this("http://localhost");
    }

    /**
     * Initializes an instance of AutoRestComplexTestService client.
     *
     * @param baseUri the base URI of the host
     */
    public AutoRestComplexTestServiceImpl(String baseUri) {
        super();
        this.baseUri = baseUri;
        initialize();
    }

    /**
     * Initializes an instance of AutoRestComplexTestService client.
     *
     * @param baseUri the base URI of the host
     * @param client the {@link OkHttpClient} client to use for REST calls
     * @param retrofitBuilder the builder for building up a {@link Retrofit}
     */
    public AutoRestComplexTestServiceImpl(String baseUri, OkHttpClient client, Retrofit.Builder retrofitBuilder) {
        super(client, retrofitBuilder);
        this.baseUri = baseUri;
        initialize();
    }

    private void initialize() {
        this.retrofitBuilder.baseUrl(baseUri);
    }
}
