/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the Salmon class.
 * @constructor
 * @member {string} [location]
 * 
 * @member {boolean} [iswild]
 * 
 */
function Salmon() {
  Salmon['super_'].call(this);
}

util.inherits(Salmon, models['Fish']);

/**
 * Defines the metadata of Salmon
 *
 * @returns {object} metadata of Salmon
 *
 */
Salmon.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'salmon',
    type: {
      name: 'Composite',
      className: 'Salmon',
      modelProperties: {
        species: {
          required: false,
          serializedName: 'species',
          type: {
            name: 'String'
          }
        },
        length: {
          required: true,
          serializedName: 'length',
          type: {
            name: 'Number'
          }
        },
        siblings: {
          required: false,
          serializedName: 'siblings',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'FishElementType',
                type: {
                  name: 'Composite',
                  polymorphicDiscriminator: 'fishtype',
                  className: 'Fish'
                }
            }
          }
        },
        fishtype: {
          required: true,
          serializedName: 'fishtype',
          type: {
            name: 'String'
          }
        },
        location: {
          required: false,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        iswild: {
          required: false,
          serializedName: 'iswild',
          type: {
            name: 'Boolean'
          }
        }
      }
    }
  };
};

module.exports = Salmon;
