/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the Sawshark class.
 * @constructor
 * @member {buffer} [picture]
 * 
 */
function Sawshark() {
  Sawshark['super_'].call(this);
}

util.inherits(Sawshark, models['Shark']);

/**
 * Defines the metadata of Sawshark
 *
 * @returns {object} metadata of Sawshark
 *
 */
Sawshark.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'sawshark',
    type: {
      name: 'Composite',
      className: 'Sawshark',
      modelProperties: {
        species: {
          required: false,
          serializedName: 'species',
          type: {
            name: 'String'
          }
        },
        length: {
          required: true,
          serializedName: 'length',
          type: {
            name: 'Number'
          }
        },
        siblings: {
          required: false,
          serializedName: 'siblings',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'FishElementType',
                type: {
                  name: 'Composite',
                  polymorphicDiscriminator: 'fishtype',
                  className: 'Fish'
                }
            }
          }
        },
        fishtype: {
          required: true,
          serializedName: 'fishtype',
          type: {
            name: 'String'
          }
        },
        age: {
          required: false,
          serializedName: 'age',
          type: {
            name: 'Number'
          }
        },
        birthday: {
          required: true,
          serializedName: 'birthday',
          type: {
            name: 'DateTime'
          }
        },
        picture: {
          required: false,
          serializedName: 'picture',
          type: {
            name: 'ByteArray'
          }
        }
      }
    }
  };
};

module.exports = Sawshark;
