/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var util = require('util');

/**
 * @class
 * Initializes a new instance of the Product class.
 * @constructor
 * The product documentation.
 * @member {array} [displayNames] Non required array of unique items from 0 to
 * 6 elements.
 * 
 * @member {number} [capacity] Non required int betwen 0 and 100 exclusive.
 * 
 * @member {string} [image] Image URL representing the product.
 * 
 */
function Product() {
}

/**
 * Defines the metadata of Product
 *
 * @returns {object} metadata of Product
 *
 */
Product.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Product',
    type: {
      name: 'Composite',
      className: 'Product',
      modelProperties: {
        displayNames: {
          required: false,
          serializedName: 'display_names',
          constraints: {
            MaxItems: 6,
            MinItems: 0,
            UniqueItems: true
          },
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        capacity: {
          required: false,
          serializedName: 'capacity',
          constraints: {
            ExclusiveMaximum: 100,
            ExclusiveMinimum: 0
          },
          type: {
            name: 'Number'
          }
        },
        image: {
          required: false,
          serializedName: 'image',
          constraints: {
            Pattern: 'http://\w+'
          },
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = Product;
